SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

Magnitude subclass: #Measure
	instanceVariableNames: 'amount unit'
	classVariableNames: 'multiplierMeasure'
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Measure subclass: #CompoundMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!CompoundMeasure class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:16'!
amount: anAmount inUnit: aCompoundUnit

	^ self new amount: anAmount inUnit: aCompoundUnit! !

!CompoundMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 16:44'!
* aCompoundMeasure

	^ CompoundMeasure amount: (amount * aCompoundMeasure amount) inUnit: (unit * aCompoundMeasure unit)! !

!CompoundMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 16:45'!
+ aCompoundMeasure

	^ CompoundMeasure amount: (amount + aCompoundMeasure amount) inUnit: unit! !

!CompoundMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:54'!
amount

	^ amount! !

!CompoundMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:16'!
amount: anAmount inUnit: aCompoundUnit

	amount := anAmount.
	unit := aCompoundUnit.! !

!CompoundMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 17:22'!
areBothRepresentingTheSame: aMeasure
	^ ((self class = aMeasure class) or: [ (self unit class = NullUnit and: NullUnit = aMeasure unit class)]) and: [ amount = aMeasure amount ]! !

!CompoundMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 16:47'!
divideAMeasure: aMeasure

	^ aMeasure multiplyAMeasure: self multiplicativeInverse! !

!CompoundMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:54'!
unit

	^ unit! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 14:58'!
* aMagnitude

 ^ aMagnitude multiplyAMeasure: self
! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:51'!
/ aMagnitude

 ^ aMagnitude divideAMeasure: self
! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 17:30'!
= aMeasure
	^ ((aMeasure isKindOf: Number) or: (aMeasure isKindOf: Measure)) and: [(self areBothZeroMeasures: aMeasure asMeasure) or: [ self areBothRepresentingTheSame: aMeasure asMeasure]]! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:55'!
amount
	^ amount! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 18:12'!
areBothRepresentingTheSame: aMeasure
	^self subclassResponsibility ! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 17:31'!
areBothZeroMeasures: aMeasure
	^ self isZero and: [ aMeasure isZero ]! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/22/2013 20:38'!
asBaseUnitAmount
	^ asBaseUnitAmount! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 17:00'!
asMeasure
	^self ! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 16:47'!
divideAMeasure: aMeasure

	^ self subclassResponsibility "aMeasure multiplyAMeasure: self multiplicativeInverse"! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/24/2013 02:11'!
hash 
	^ asBaseUnitAmount ! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:54'!
isZero
	^ self amount = 0 and: [ (self unit = SimpleUnit celsius ) not ]! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:01'!
multiplicativeInverse

	^ CompoundMeasure amount: (1 / self amount) inUnit: self unit multiplicativeInverse ! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 14:56'!
multiplyAMeasure: aMeasure

	^ CompoundMeasure amount: (aMeasure amount * self amount) inUnit: (aMeasure unit * self unit)! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 14:57'!
multiplyANumber: aNumber

	^ self subclassResponsibility ! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/24/2013 01:48'!
printString

	| unitString |
	unitString := unit printString .
	
	^ self amount asInteger printString , ' ', ((unitString endsWith: 's') 
		ifTrue: [ unitString ] 
		ifFalse: [ unitString asPluralBasedOn: self amount abs ])! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/22/2013 20:38'!
unit
	^ unit! !

Measure subclass: #SimpleMeasure
	instanceVariableNames: 'asBaseUnitAmount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!SimpleMeasure class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:52'!
amount: anAmount inUnit: aSimpleUnit 

	^self new amount:anAmount inUnit: aSimpleUnit ! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:49'!
+ aSimpleMeasure

	^ SimpleMeasure amount: self amount+(aSimpleMeasure convertTo: unit) amount inUnit: unit! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:49'!
- aSimpleMeasure
	
	^ self + aSimpleMeasure negated! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 16:00'!
< aSimpleMeasure

	^ (unit isConvertibleTo: aSimpleMeasure unit) and: [self asBaseUnitAmount < aSimpleMeasure asBaseUnitAmount]! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:53'!
amount: anAmount inUnit: aUnit

	amount := anAmount.
	asBaseUnitAmount := aUnit toBaseUnitMethod value: anAmount.
	unit := aUnit.! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 15:45'!
areBothRepresentingTheSame: aMeasure
	^ (self class = aMeasure class) and: [(unit isConvertibleTo: aMeasure unit) and: [ asBaseUnitAmount = aMeasure asBaseUnitAmount ]]! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 15:58'!
asBaseUnitAmount
	
	^ asBaseUnitAmount
	! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:58'!
between: aSimpleMeasure and: anotherSimpleMeasure
	
	^   self < (aSimpleMeasure max: anotherSimpleMeasure ) and: self > (aSimpleMeasure min: anotherSimpleMeasure )! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:47'!
convertTo: aSimpleUnit 
	
	|newAmount|
	(self unit isConvertibleTo: aSimpleUnit) ifFalse: [ ^self error: 'No puedo convertir entre esas unidades.' ].
	
	newAmount:= aSimpleUnit fromBaseUnitMethod value: self asBaseUnitAmount.
	
	^ SimpleMeasure amount: newAmount inUnit: aSimpleUnit
	! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:59'!
copy 

	^ SimpleMeasure amount: amount inUnit: unit! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 17:05'!
divideAMeasure: aMeasure

	^ CompoundMeasure amount: (aMeasure asBaseUnitAmount / self asBaseUnitAmount) inUnit: (aMeasure unit / self unit)! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:59'!
hash

	^ asBaseUnitAmount ! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:54'!
multiplyANumber: aNumber

	^ SimpleMeasure amount:  self amount  * aNumber inUnit: unit! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:51'!
negated

	^ self * (-1)! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 15:49'!
to: aSimpleMeasure 
	
	^ MeasureInterval from: self to: aSimpleMeasure
	! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 15:50'!
to: aSimpleMeasure by: anotherSimpleMeasure
	
	^ MeasureInterval from: self to: aSimpleMeasure by: anotherSimpleMeasure
	! !

Magnitude subclass: #Number
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Number commentStamp: 'StephaneDucasse 11/1/2010 07:50' prior: 0!
Class Number holds the most general methods for dealing with numbers. Subclasses Float, Fraction, and Integer, and their subclasses, provide concrete representations of a numeric quantity.

All of Number's subclasses participate in a simple type coercion mechanism that supports mixed-mode arithmetic and comparisons.  It works as follows:  If
	self<typeA> op: arg<typeB>
fails because of incompatible types, then it is retried in the following guise:
	(arg adaptTypeA: self) op: arg adaptToTypeA.
This gives the arg of typeB an opportunity to resolve the incompatibility, knowing exactly what two types are involved.  If self is more general, then arg will be converted, and viceVersa.  This mechanism is extensible to any new number classes that one might wish to add to Squeak.  The only requirement is that every subclass of Number must support a pair of conversion methods specific to each of the other subclasses of Number.

Implementation notes
----------------------------------
The implementation of #degreeCos and #degreeSin is such that results are exact for any multiple of 90.

Care is also taken to evaluate the sine between -90 and 90, this will avoid #degreesToRadians and i386 FPU sine fonction to accumulate round off errors due to approximate representation of pi.
We can thus evaluate 240 degreeCos with at most 1 ulp error. It's not perfect, but better than previous implementation.

For cosine, we know that:
	cosd(x)=cosd(abs(x))
	cosd(x)=sind(90-x)
thus the trick is to evaluate:
	cosd(x)=sind(90-abs(x)) after appropriate modulo in [-180,180[
This way, we are sure to evaluate the sine between -90 and 90
The #degreesToRadians and #sin are used rather than #degreeSin to avoid cycles.

For sine, it would be necessary to evaluate either
sind(x) if abs(x) <=90
or sind(180-x) if abs(x) >= 90
A possible implementation would be:
	| x |
	x := 90 + self \\ 360 - 90.
	x >= 180 ifTrue: [x := 180 - x].
	^x degreesToRadians sin
We prefer evaluating cosd(90-x) thus providing a branch free implementation.!

!Number class methodsFor: 'constants' stamp: 'GabrielOmarCotelli 5/23/2009 20:46'!
one

	^1! !

!Number class methodsFor: 'deprecated' stamp: 'dtl 7/3/2006 17:41'!
readExponent: baseValue base: base from: aStream
	"Complete creation of a number, reading exponent from aStream. Answer the
	number, or nil if parsing fails.
	<number>(e|d|q)<exponent>>"

	| sign exp value |
	('edq' includes: aStream next) ifFalse: [^ nil].
	sign := ((aStream peek) == $-)
		ifTrue: [aStream next. -1]
		ifFalse: [1].
	(aStream atEnd or: [(aStream peek digitValue between: 0 and: 9) not])
		ifTrue: [^ nil]. "Avoid throwing an error"
	exp := (Integer readFrom: aStream base: 10) * sign.
	value := baseValue * (base raisedTo: exp).
	^ value
! !

!Number class methodsFor: 'instance creation' stamp: 'nice 10/22/2009 18:46'!
readFrom: stringOrStream 
	"Answer a number as described on aStream.  The number may
	be any accepted Smalltalk literal Number format.
	It can include a leading radix specification, as in 16rFADE.
	It can as well be NaN, Infinity or -Infinity for conveniency.
	If stringOrStream does not start with a valid number description, fail."
	
	^(SqNumberParser on: stringOrStream) nextNumber! !

!Number class methodsFor: 'instance creation' stamp: 'GuillermoPolito 8/24/2010 18:50'!
readFrom: stringOrStream base: base
	"Answer a number as described on aStream in the given number base.
	If stringOrStream does not start with a valid number description, answer 0 for backward compatibility. This is not clever and should better be changed."

	^(SqNumberParser on: stringOrStream) nextNumberBase: base! !

!Number class methodsFor: 'instance creation' stamp: 'nice 3/15/2008 00:42'!
readFrom: stringOrStream ifFail: aBlock
	"Answer a number as described on aStream.  The number may
	be any accepted Smalltalk literal Number format.
	It can include a leading radix specification, as in 16rFADE.
	It can as well be NaN, Infinity or -Infinity for conveniency.
	If input does not represent a valid number, then execute fail block
	and leave the stream positioned before offending character"
	
	^(SqNumberParser on: stringOrStream) failBlock: aBlock; nextNumber! !

!Number class methodsFor: 'deprecated' stamp: 'dtl 7/4/2006 08:32'!
readRemainderOf: integerPart from: aStream base: base withSign: sign 
	"Read optional fractional part and exponent or decimal scale, and return the final result"
	"Changed 200/01/19 For ANSI Numeric Literals support."
	"Number readFrom: '3r-22.2'"

	| value fractionDigits fracpos fractionPart fraction pos v foundDecimal |
	#Numeric.
	value := integerPart.
	fractionDigits := 0.
	foundDecimal := false.
	(aStream peekFor: $.)
		ifTrue: ["<integer>.<fraction>"
			foundDecimal := true.
			(aStream atEnd not
					and: [aStream peek digitValue between: 0 and: base - 1])
				ifTrue: [fracpos := aStream position.
					fractionPart := Integer readFrom: aStream base: base.
					fraction := fractionPart asFloat
								/ (base raisedTo: aStream position - fracpos).
					fractionDigits := aStream position - fracpos.
					value := value asFloat + fraction]].

	pos := aStream position.
	(v := self readScaledDecimal: integerPart
			fractionPart: fractionPart
			digits: fractionDigits
			base: base
			sign: sign
			from: aStream)
		ifNil: [aStream position: pos]
		ifNotNil: [^ v "<number>s<scale>>"].

	pos := aStream position.
	(v := self readExponent: value base: base from: aStream)
		ifNil: [aStream position: pos.
			(foundDecimal and: [fractionDigits = 0])
				ifTrue: ["oops - just <integer>."
							aStream skip: -1.
							"un-gobble the period"
							^ value * sign]]
		ifNotNil: [value := v "<number>(e|d|q)<exponent>>"].

	(value isFloat
			and: [value = 0.0
					and: [sign = -1]])
		ifTrue: [^ Float negativeZero]
		ifFalse: [^ value * sign]! !

!Number class methodsFor: 'deprecated' stamp: 'nice 5/16/2009 22:11'!
readScaledDecimal: integerPart fractionPart: fractionPart digits: fractionDigits base: base sign: sign from: aStream 
	"Complete creation of a ScaledDecimal, reading scale from aStream. Answer
	a ScaledDecimal, or nil if parsing fails.
	<number>s[<scale>]"

	| scale decimalMultiplier decimalFraction |
	aStream atEnd ifTrue: [^ nil].
	(aStream next == $s) ifFalse: [^ nil].
	"<number>s<scale>"
	(aStream atEnd not and: [aStream peek digitValue between: 0 and: 9])
		ifTrue: [scale := Integer readFrom: aStream]
		ifFalse: [^ nil].
	scale isNil
		ifTrue: ["<number>s"
			fractionDigits = 0
				ifTrue: ["<integer>s"
					scale := 0]
				ifFalse: ["<integer>.<fraction>s"
					scale := fractionDigits]].
	fractionPart isNil
		ifTrue: [^integerPart * sign asScaledDecimal: scale]
		ifFalse: [decimalMultiplier := base raisedTo: fractionDigits.
			decimalFraction := integerPart * decimalMultiplier + fractionPart * sign / decimalMultiplier.
			^decimalFraction asScaledDecimal: scale]! !

!Number class methodsFor: 'instance creation' stamp: 'nice 4/28/2012 16:11'!
readSmalltalkSyntaxFrom: stringOrStream 
	"Answer a number as described on aStream.  The number may
	be any accepted Smalltalk literal Number format.
	It can include a leading radix specification, as in 16rFADE.
	It can as well be NaN, Infinity or -Infinity for conveniency.
	If stringOrStream does not start with a valid number description, fail."
	
	^(SqNumberParser on: stringOrStream) nextNumber! !

!Number class methodsFor: 'instance creation' stamp: 'NikoSchwarz 10/23/2009 13:18'!
squeezeNumberOutOfString: stringOrStream
	"Try and find a number in this string. First, look if the string 
	starts with a number. Then, see if it ends with a number. Then,
	remove a character from the front and see if the remaining 
	string makes a number. Repeat the process until no characters
	are left or the number has been found. As soon as a number is
	found, it is returned. Otherwise, the method fails."
	^ SqNumberParser squeezeNumberOutOfString: stringOrStream! !

!Number class methodsFor: 'instance creation' stamp: 'NikoSchwarz 10/23/2009 13:19'!
squeezeNumberOutOfString: stringOrStream ifFail: aBlock
	"Try and find a number in this string. First, look if the string 
	starts with a number. Then, see if it ends with a number. Then,
	remove a character from the front and see if the remaining 
	string makes a number. Repeat the process until no characters
	are left or the number has been found. As soon as a number is
	found, it is returned. Otherwise, the method fails."
	^ SqNumberParser squeezeNumberOutOfString: stringOrStream onError: aBlock! !

!Number methodsFor: 'mathematical functions' stamp: 'CamilloBruni 7/13/2012 17:37'!
% aNumber 
	"modulo. Remainder defined in terms of //. Answer a Number with the 
	same sign as aNumber. e.g. 9\\4 = 1, -9\\4 = 3, 9\\-4 = -3, 0.9\\0.4 = 0.1."
	^ self \\ aNumber! !

!Number methodsFor: 'arithmetic' stamp: 'AlejandraRodriguez 5/25/2013 16:12'!
* aNumber 
	"Answer the result of multiplying the receiver by aNumber."

	self subclassResponsibility

	! !

!Number methodsFor: 'mathematical functions' stamp: 'CamilloBruni 7/10/2012 22:24'!
** exponent 
	" A shortcut methog for raisedTo: "
	^ self raisedTo: exponent! !

!Number methodsFor: 'arithmetic' stamp: ''!
+ aNumber 
	"Answer the sum of the receiver and aNumber."

	self subclassResponsibility! !

!Number methodsFor: 'arithmetic' stamp: ''!
- aNumber 
	"Answer the difference between the receiver and aNumber."

	self subclassResponsibility! !

!Number methodsFor: 'arithmetic' stamp: ''!
/ aNumber 
	"Answer the result of dividing the receiver by aNumber."

	self subclassResponsibility! !

!Number methodsFor: 'arithmetic' stamp: ''!
// aNumber 
	"Integer quotient defined by division with truncation toward negative 
	infinity. 9//4 = 2, -9//4 = -3. -0.9//0.4 = -3. \\ answers the remainder 
	from this division."

	^(self / aNumber) floor! !

!Number methodsFor: 'converting' stamp: ''!
@ y 
	"Primitive. Answer a Point whose x value is the receiver and whose y 
	value is the argument. Optional. No Lookup. See Object documentation 
	whatIsAPrimitive."

	<primitive: 18>
	^Point x: self y: y! !

!Number methodsFor: 'arithmetic' stamp: ''!
\\ aNumber 
	"modulo. Remainder defined in terms of //. Answer a Number with the 
	same sign as aNumber. e.g. 9\\4 = 1, -9\\4 = 3, 9\\-4 = -3, 0.9\\0.4 = 0.1."

	^self - (self // aNumber * aNumber)! !

!Number methodsFor: 'arithmetic' stamp: ''!
abs
	"Answer a Number that is the absolute value (positive magnitude) of the 
	receiver."

	self < 0
		ifTrue: [^self negated]
		ifFalse: [^self]! !

!Number methodsFor: 'converting' stamp: 'di 11/6/1998 13:43'!
adaptToCollection: rcvr andSend: selector
	"If I am involved in arithmetic with a Collection, return a Collection of
	the results of each element combined with me in that expression."

	^ rcvr collect: [:element | element perform: selector with: self]! !

!Number methodsFor: 'converting' stamp: 'nice 1/4/2009 20:31'!
adaptToFloat: rcvr andCompare: selector 
	"If I am involved in comparison with a Float, convert rcvr to a
	Fraction. This way, no bit is lost and comparison is exact."
	
	rcvr isFinite
		ifFalse: [
			selector == #= ifTrue: [^false].
			selector == #~= ifTrue: [^true].
			rcvr isNaN ifTrue: [^ false].
			(selector = #< or: [selector = #'<='])
				ifTrue: [^ rcvr positive not].
			(selector = #> or: [selector = #'>='])
				ifTrue: [^ rcvr positive].
			^self error: 'unknow comparison selector'].

	^ rcvr asTrueFraction perform: selector with: self! !

!Number methodsFor: 'converting' stamp: 'di 11/6/1998 13:21'!
adaptToFloat: rcvr andSend: selector 
	"If I am involved in arithmetic with a Float, convert me to a Float."
	^ rcvr perform: selector with: self asFloat! !

!Number methodsFor: 'converting' stamp: 'di 11/6/1998 13:44'!
adaptToFraction: rcvr andSend: selector
	"If I am involved in arithmetic with a Fraction, convert us and evaluate exprBlock."
	^ self subclassResponsibility! !

!Number methodsFor: 'converting' stamp: 'di 11/6/1998 13:44'!
adaptToInteger: rcvr andSend: selector
	"If I am involved in arithmetic with a Integer, convert us and evaluate exprBlock."
	^ self subclassResponsibility! !

!Number methodsFor: 'converting' stamp: 'di 11/6/1998 13:44'!
adaptToPoint: rcvr andSend: selector
	"If I am involved in arithmetic with a Point, convert me to a Point."
	^ rcvr perform: selector with: self@self! !

!Number methodsFor: 'converting' stamp: 'di 11/6/1998 13:45'!
adaptToString: rcvr andSend: selector
	"If I am involved in arithmetic with a String, convert it to a Number."
	^ rcvr asNumber perform: selector with: self! !

!Number methodsFor: 'mathematical functions' stamp: ''!
arcCos 
	"The receiver is the cosine of an angle. Answer the angle measured in 
	radians."

	^self asFloat arcCos! !

!Number methodsFor: 'mathematical functions' stamp: ''!
arcSin
	"The receiver is the sine of an angle. Answer the angle measured in 
	radians."

	^self asFloat arcSin! !

!Number methodsFor: 'mathematical functions' stamp: ''!
arcTan
	"The receiver is the tangent of an angle. Answer the angle measured in 
	radians."

	^self asFloat arcTan! !

!Number methodsFor: 'mathematical functions' stamp: 'jsp 2/24/1999 15:20'!
arcTan: denominator
	"The receiver is the tangent of an angle. Answer the angle measured in 
	radians."

	^(self asFloat) arcTan: denominator.! !

!Number methodsFor: 'arithmetic' stamp: 'mk 10/27/2003 21:00'!
arg
	"Answer the argument of the receiver (see Complex | arg)."
	
	self isZero ifTrue: [self error: 'Zero (0 + 0 i) does not have an argument.'].
	0 < self
		ifTrue: [^ 0]
		ifFalse: [^ Float pi]! !

!Number methodsFor: 'converting' stamp: 'ar 5/20/2001 01:40'!
asB3DVector3
	^self@self@self! !

!Number methodsFor: 'converting' stamp: 'brp 5/13/2003 10:13'!
asDuration
 
 	^ Duration nanoSeconds: self asInteger
 ! !

!Number methodsFor: 'converting' stamp: 'SvenVanCaekenberghe 3/8/2012 08:20'!
asFloat
	"Answer a floating-point number approximating the receiver."

	self subclassResponsibility! !

!Number methodsFor: 'converting' stamp: 'RAH 4/25/2000 19:49'!
asFloatD
	"Answer a d precision floating-point number approximating the receiver."
	#Numeric.
	"add 200/01/19 For ANSI <number> protocol."
	^ self asFloat! !

!Number methodsFor: 'converting' stamp: 'RAH 4/25/2000 19:49'!
asFloatE
	"Answer a floating-point number approximating the receiver."
	#Numeric.
	"add 200/01/19 For ANSI <number> protocol."
	^ self asFloat! !

!Number methodsFor: 'converting' stamp: 'RAH 4/25/2000 19:49'!
asFloatQ
	"Answer a floating-point number approximating the receiver."
	#Numeric.
	"add 200/01/19 For ANSI <number> protocol."
	^ self asFloat! !

!Number methodsFor: 'converting' stamp: ''!
asInteger
	"Answer an Integer nearest the receiver toward zero."

	^self truncated! !

!Number methodsFor: 'converting' stamp: 'AlejandraRodriguez 5/26/2013 17:14'!
asMeasure
	^SimpleMeasure amount: self inUnit: NullUnit initialize! !

!Number methodsFor: 'converting' stamp: 'sw 2/16/1999 18:15'!
asNumber
	^ self! !

!Number methodsFor: 'converting' stamp: ''!
asPoint
	"Answer a Point with the receiver as both coordinates; often used to 
	supply the same value in two dimensions, as with symmetrical gridding 
	or scaling."

	^self @ self! !

!Number methodsFor: 'converting' stamp: 'dtl 9/25/2004 11:47'!
asScaledDecimal
	"Answer a scaled decimal number approximating the receiver."
	#Numeric.

	^ self asScaledDecimal: 8
! !

!Number methodsFor: 'converting' stamp: 'nice 5/16/2009 22:46'!
asScaledDecimal: scale 
	"Answer the receiver converted to a ScaledDecimal."
	
	^ ScaledDecimal newFromNumber: self scale: scale! !

!Number methodsFor: 'converting' stamp: 'sw 9/8/97 16:30'!
asSmallAngleDegrees
	"Return the receiver normalized to lie within the range (-180, 180)"

	| pos |
	pos := self \\ 360.
	pos > 180 ifTrue: [pos := pos - 360].
	^ pos

"#(-500 -300 -150 -5 0 5 150 300 500 1200) collect: [:n | n asSmallAngleDegrees]"! !

!Number methodsFor: 'converting' stamp: 'nice 10/5/2009 21:28'!
asSmallPositiveDegrees
	"Return the receiver normalized to lie within the range (0, 360)"

	^self \\ 360! !

!Number methodsFor: 'truncation and round off' stamp: ''!
ceiling
	"Answer the integer nearest the receiver toward positive infinity."

	self <= 0.0
		ifTrue: [^self truncated]
		ifFalse: [^self negated floor negated]! !

!Number methodsFor: 'comparing' stamp: 'nice 12/26/2009 18:46'!
closeTo: num
	"are these two numbers close?"

	num isFloat ifTrue: [^ num closeTo: self asFloat].
	^[self = num] ifError: [false]! !

!Number methodsFor: 'mathematical functions' stamp: 'Janniklaval 10/23/2010 13:45'!
copySignTo: aNumber
      "Return a number with same magnitude as aNumber and same sign as self."

      ^ self positive
              ifTrue: [aNumber abs]
              ifFalse: [aNumber abs negated].! !

!Number methodsFor: 'mathematical functions' stamp: ''!
cos
	"The receiver represents an angle measured in radians. Answer its cosine."

	^self asFloat cos! !

!Number methodsFor: 'converting' stamp: 'brp 1/9/2004 06:12'!
day
 
 	^ self sign days! !

!Number methodsFor: 'converting' stamp: 'brp 5/16/2003 07:56'!
days
 
 	^ Duration days: self! !

!Number methodsFor: 'mathematical functions' stamp: 'nice 10/31/2010 22:03'!
degreeCos
	"Answer the cosine of the receiver taken as an angle in degrees."
	
	^ (90 - (180 + self \\ 360 - 180) abs) degreesToRadians sin! !

!Number methodsFor: 'mathematical functions' stamp: 'nice 10/31/2010 22:01'!
degreeSin
	"Answer the sine of the receiver taken as an angle in degrees."
	
	^(90 - self) degreeCos! !

!Number methodsFor: 'converting' stamp: ''!
degreesToRadians
	"The receiver is assumed to represent degrees. Answer the conversion to 
	radians."

	^self asFloat degreesToRadians! !

!Number methodsFor: 'truncation and round off' stamp: 'di 2/19/98 21:58'!
detentBy: detent atMultiplesOf: grid snap: snap
	"Map all values that are within detent/2 of any multiple of grid to that multiple.  Otherwise, if snap is true, return self, meaning that the values in the dead zone will never be returned.  If snap is false, then expand the range between dead zones so that it covers the range between multiples of the grid, and scale the value by that factor."
	| r1 r2 |
	r1 := self roundTo: grid.  "Nearest multiple of grid"
	(self roundTo: detent) = r1 ifTrue: [^ r1].  "Snap to that multiple..."
	snap ifTrue: [^ self].  "...or return self"

	r2 := self < r1  "Nearest end of dead zone"
		ifTrue: [r1 - (detent asFloat/2)]
		ifFalse: [r1 + (detent asFloat/2)].
	"Scale values between dead zones to fill range between multiples"
	^ r1 + ((self - r2) * grid asFloat / (grid - detent))
"
	(170 to: 190 by: 2) collect: [:a | a detentBy: 10 atMultiplesOf: 90 snap: true] 	(170 to: 190 by: 2) collect: [:a | a detentBy: 10 atMultiplesOf: 90 snap: false]
	(3.9 to: 4.1 by: 0.02) collect: [:a | a detentBy: 0.1 atMultiplesOf: 1.0 snap: true] 	(-3.9 to: -4.1 by: -0.02) collect: [:a | a detentBy: 0.1 atMultiplesOf: 1.0 snap: false]
"! !

!Number methodsFor: 'arithmetic' stamp: 'AlejandraRodriguez 5/25/2013 14:57'!
divideAMeasure: aMeasure

	^ aMeasure multiplyANumber: (1/self)! !

!Number methodsFor: 'testing' stamp: ''!
even
	"Answer whether the receiver is an even number."

	^self \\ 2 = 0! !

!Number methodsFor: 'mathematical functions' stamp: ''!
exp
	"Answer the exponential of the receiver as a floating point number."

	^self asFloat exp! !

!Number methodsFor: 'truncation and round off' stamp: ''!
floor
	"Answer the integer nearest the receiver toward negative infinity."

	| truncation |
	truncation := self truncated.
	self >= 0 ifTrue: [^truncation].
	self = truncation
		ifTrue: [^truncation]
		ifFalse: [^truncation - 1]! !

!Number methodsFor: 'mathematical functions' stamp: 'jm 3/27/98 06:16'!
floorLog: radix
	"Answer the floor of the log base radix of the receiver."

	^ self asFloat floorLog: radix
! !

!Number methodsFor: 'truncation and round off' stamp: 'StephaneDucasse 5/8/2010 17:14'!
fractionPart
	"Added for ANSI compatibility"
	^self - self integerPart! !

!Number methodsFor: 'converting' stamp: 'brp 1/9/2004 06:28'!
hour
 
 	^ self sign hours
 ! !

!Number methodsFor: 'converting' stamp: 'brp 5/16/2003 07:56'!
hours
 
 	^ Duration hours: self! !

!Number methodsFor: 'truncation and round off' stamp: 'GabrielOmarCotelli 5/26/2009 21:57'!
integerPart
	"Added for ANSI compatibility"
	^self truncated! !

!Number methodsFor: 'mathematical functions' stamp: 'ar 8/31/2000 20:05'!
interpolateTo: aNumber at: param
	^self + (aNumber - self * param)! !

!Number methodsFor: 'testing' stamp: 'sw 12/30/1998 13:21'!
isDivisibleBy: aNumber
	aNumber = 0 ifTrue: [^ false].
	aNumber isInteger ifFalse: [^ false].
	^ (self \\ aNumber) = 0! !

!Number methodsFor: 'testing' stamp: 'tao 4/19/98 23:33'!
isInfinite

	^ false! !

!Number methodsFor: 'testing' stamp: 'tao 10/10/97 16:36'!
isNaN
	^ false! !

!Number methodsFor: 'testing' stamp: ''!
isNumber
	^ true! !

!Number methodsFor: 'printing' stamp: 'sw 6/29/1999 21:10'!
isOrAreStringWith: aNoun
	| result |
	result := self = 1
		ifTrue:
			[' is one ']
		ifFalse:
			[self = 0
				ifTrue:
					[' are no ']
				ifFalse:
					[' are ', self printString, ' ']].
	result := result, aNoun.
	self = 1 ifFalse: [result := result, 's'].
	^ result

"#(0 1 2 98.6) do:
	[:num | Transcript cr; show: 'There', (num isOrAreStringWith: 'way'), ' to skin a cat']"! !

!Number methodsFor: 'testing' stamp: ''!
isZero
	^self = 0! !

!Number methodsFor: 'mathematical functions' stamp: ''!
ln
	"Answer the natural log of the receiver."

	^self asFloat ln! !

!Number methodsFor: 'mathematical functions' stamp: 'di 9/8/1998 17:10'!
log
	"Answer the base-10 log of the receiver."

	^self asFloat log! !

!Number methodsFor: 'mathematical functions' stamp: ''!
log: aNumber 
	"Answer the log base aNumber of the receiver."

	^self ln / aNumber ln! !

!Number methodsFor: 'converting' stamp: 'brp 1/9/2004 06:26'!
milliSecond
 
 	^ self sign milliSeconds
 ! !

!Number methodsFor: 'converting' stamp: 'brp 9/25/2003 13:16'!
milliSeconds
 
 	^ Duration milliSeconds: self
 ! !

!Number methodsFor: 'converting' stamp: 'brp 1/9/2004 06:16'!
minute
 
 	^ self sign minutes
 ! !

!Number methodsFor: 'converting' stamp: 'brp 5/16/2003 07:56'!
minutes
 
 	^ Duration minutes: self! !

!Number methodsFor: 'arithmetic' stamp: 'AlejandraRodriguez 5/25/2013 14:58'!
multiplyAMeasure: aMeasure

	^ aMeasure multiplyANumber: self! !

!Number methodsFor: 'converting' stamp: 'brp 1/9/2004 06:27'!
nanoSecond
 
 	^ self sign nanoSeconds
 ! !

!Number methodsFor: 'converting' stamp: 'brp 5/16/2003 08:52'!
nanoSeconds
 
 	^ Duration nanoSeconds: self.! !

!Number methodsFor: 'arithmetic' stamp: ''!
negated
	"Answer a Number that is the negation of the receiver."

	^0 - self! !

!Number methodsFor: 'testing' stamp: 'di 4/23/1998 11:18'!
negative
	"Answer whether the receiver is mathematically negative."

	^ self < 0! !

!Number methodsFor: 'mathematical functions' stamp: 'jmv 10/13/2011 08:36'!
nthRoot: aPositiveInteger
	"Answer the nth root of the receiver."

	self subclassResponsibility! !

!Number methodsFor: 'testing' stamp: ''!
odd
	"Answer whether the receiver is an odd number."

	^self even == false! !

!Number methodsFor: 'testing' stamp: 'di 4/23/1998 11:17'!
positive
	"Answer whether the receiver is positive or equal to 0. (ST-80 protocol).
	See also strictlyPositive"

	^ self >= 0! !

!Number methodsFor: 'printing' stamp: 'laza 3/29/2004 12:53'!
printOn: aStream
	self printOn: aStream base: 10! !

!Number methodsFor: 'printing' stamp: 'nice 9/25/2007 02:36'!
printOn: aStream base: base
	"This method should print a representation of the number for the given base,
	excluding the base prefix (and the letter r for radix)"
	
	^self subclassResponsibility! !

!Number methodsFor: 'printing' stamp: 'nice 3/29/2011 21:48'!
printOn: aStream showingDecimalPlaces: placesDesired
	"Print a representation of the receiver on aStream in decimal notation with prescribed number of places after decimal separator."

	| rounder rounded roundedFractionPart |
	placesDesired <= 0 ifTrue: [^ self rounded printOn: aStream].
	rounder := 10 raisedToInteger: placesDesired.
	rounded := self roundTo: rounder reciprocal.
	rounded negative ifTrue: [aStream nextPut: $-].
	rounded := rounded abs.
	rounded integerPart truncated printOn: aStream.
	aStream nextPut: $..
	roundedFractionPart := (rounded fractionPart * rounder) truncated.
	roundedFractionPart printOn: aStream base: 10 length: placesDesired padded: true! !

!Number methodsFor: 'printing' stamp: 'nice 3/29/2011 21:39'!
printShowingDecimalPlaces: placesDesired
	"Print the receiver showing precisely the given number of places desired.  If placesDesired is positive, a decimal point and that many digits after the decimal point will always be shown.  If placesDesired is zero, a whole number will be shown, without a decimal point."

	^String new: placesDesired + 10 streamContents: [:aStream |
		self printOn: aStream showingDecimalPlaces: placesDesired]
"
23 printShowingDecimalPlaces: 2
23.5698 printShowingDecimalPlaces: 2
-234.567 printShowingDecimalPlaces: 5
23.4567 printShowingDecimalPlaces: 0
23.5567 printShowingDecimalPlaces: 0
-23.4567 printShowingDecimalPlaces: 0
-23.5567 printShowingDecimalPlaces: 0
100000000 printShowingDecimalPlaces: 1
0.98 printShowingDecimalPlaces: 5
-0.98 printShowingDecimalPlaces: 2
2.567 printShowingDecimalPlaces: 2
-2.567 printShowingDecimalPlaces: 2
0 printShowingDecimalPlaces: 2
"! !

!Number methodsFor: 'printing' stamp: 'laza 3/30/2004 10:50'!
printString
	^self printStringBase: 10! !

!Number methodsFor: 'printing' stamp: ''!
printStringBase: base
	^ String streamContents:
		[:strm | self printOn: strm base: base]! !

!Number methodsFor: 'arithmetic' stamp: ''!
quo: aNumber 
	"Integer quotient defined by division with truncation toward zero. -9 quo: 
	4 = -2, -0.9 quo: 0.4 = -2. rem: answers the remainder from this division."

	^(self / aNumber) truncated! !

!Number methodsFor: 'converting' stamp: ''!
radiansToDegrees
	"The receiver is assumed to represent radians. Answer the conversion to 
	degrees."

	^self asFloat radiansToDegrees! !

!Number methodsFor: 'mathematical functions' stamp: 'nice 12/6/2007 21:46'!
raisedTo: aNumber 
	"Answer the receiver raised to aNumber."

	aNumber isInteger ifTrue:
		["Do the special case of integer power"
		^ self raisedToInteger: aNumber].
	self < 0 ifTrue:
		[ self error: self printString, ' raised to a non-integer power' ].
	0 = aNumber ifTrue: [^ self class one].	"Special case of exponent=0"
	1 = aNumber ifTrue: [^ self].	"Special case of exponent=1"
	0 = self ifTrue: [				"Special case of self = 0"
		aNumber < 0
			ifTrue: [^ (ZeroDivide dividend: self) signal]
			ifFalse: [^ self]].
	^ (aNumber * self ln) exp		"Otherwise use logarithms"! !

!Number methodsFor: 'mathematical functions' stamp: 'GabrielOmarCotelli 5/26/2009 19:49'!
raisedToInteger: anInteger

	"The 0 raisedToInteger: 0 is an special case. In some contexts must be 1 and in others must
	be handled as an indeterminate form.
	I take the first context because that's the way that was previously handled.
	Maybe further discussion is required on this topic."
	
	|bitProbe result|

	anInteger negative ifTrue: [^(self raisedToInteger: anInteger negated) reciprocal].
	bitProbe := 1 bitShift: anInteger highBit - 1.
 	result := self class one.
  	[
		(anInteger bitAnd: bitProbe) = 0 ifFalse: [result := result * self].
       bitProbe := bitProbe bitShift: -1.
		bitProbe > 0 ]
	whileTrue: [result := result * result].
	
	^result! !

!Number methodsFor: 'arithmetic' stamp: 'GabrielOmarCotelli 5/23/2009 20:20'!
reciprocal
	"Returns the reciprocal of self.
	In case self is 0 the / signals ZeroDivide"
	
	^1 / self! !

!Number methodsFor: 'truncation and round off' stamp: ''!
reduce
    "If self is close to an integer, return that integer"
    ^ self! !

!Number methodsFor: 'arithmetic' stamp: ''!
rem: aNumber 
	"Remainder defined in terms of quo:. Answer a Number with the same 
	sign as self. e.g. 9 rem: 4 = 1, -9 rem: 4 = -1. 0.9 rem: 0.4 = 0.1."

	^self - ((self quo: aNumber) * aNumber)! !

!Number methodsFor: 'truncation and round off' stamp: 'GuillermoPolito 6/22/2012 14:49'!
round: numberOfWishedDecimal
	self subclassResponsibility! !

!Number methodsFor: 'truncation and round off' stamp: 'StephaneDucasse 5/8/2010 17:13'!
roundDownTo: aNumber
	"Answer the next multiple of aNumber toward negative infinity that is nearest the receiver."
	
	^(self / aNumber) floor * aNumber! !

!Number methodsFor: 'truncation and round off' stamp: 'di 10/4/1999 08:08'!
roundTo: quantum 
	"Answer the nearest number that is a multiple of quantum."

	^(self / quantum) rounded * quantum! !

!Number methodsFor: 'truncation and round off' stamp: 'StephaneDucasse 5/8/2010 17:13'!
roundUpTo: aNumber 
	"Answer the next multiple of aNumber toward infinity that is nearest the receiver."

	^(self / aNumber) ceiling * aNumber! !

!Number methodsFor: 'truncation and round off' stamp: ''!
rounded
	"Answer the integer nearest the receiver."

	^(self + (self sign / 2)) truncated! !

!Number methodsFor: 'converting' stamp: 'brp 1/9/2004 06:17'!
second
 
 	^ self sign seconds
 ! !

!Number methodsFor: 'converting' stamp: 'brp 5/16/2003 07:57'!
seconds
 
 	^ Duration seconds: self! !

!Number methodsFor: 'mathematical functions' stamp: ''!
sign
	"Answer 1 if the receiver is greater than 0, -1 if less than 0, else 0."

	self > 0 ifTrue: [^1].
	self < 0 ifTrue: [^-1].
	^0! !

!Number methodsFor: 'mathematical functions' stamp: 'Janniklaval 10/23/2010 13:47'!
sign: aNumber
 	"Return a Number with the same sign as aNumber"
 
 	^ aNumber copySignTo: self.! !

!Number methodsFor: 'mathematical functions' stamp: ''!
sin
	"The receiver represents an angle measured in radians. Answer its sine."

	^self asFloat sin! !

!Number methodsFor: 'mathematical functions' stamp: ''!
sqrt
	"Answer the square root of the receiver."

	^self asFloat sqrt! !

!Number methodsFor: 'mathematical functions' stamp: ''!
squared
	"Answer the receiver multipled by itself."

	^self * self! !

!Number methodsFor: 'printing' stamp: 'laza 3/29/2004 12:50'!
storeOn: aStream 
	self printOn: aStream! !

!Number methodsFor: 'printing' stamp: 'nice 9/25/2007 02:35'!
storeOn: aStream base: base
	"This method should print a representation of the number for the given base,
	including the base prefix (with letter r for radix)"
	
	^self subclassResponsibility! !

!Number methodsFor: 'printing' stamp: ''!
storeStringBase: base
	^ String streamContents: [:strm | self storeOn: strm base: base]! !

!Number methodsFor: 'testing' stamp: 'di 4/23/1998 11:02'!
strictlyPositive
	"Answer whether the receiver is mathematically positive."

	^ self > 0! !

!Number methodsFor: 'printing' stamp: 'sw 7/1/1998 12:33'!
stringForReadout
	^ self rounded printString! !

!Number methodsFor: 'mathematical functions' stamp: ''!
tan
	"The receiver represents an angle measured in radians. Answer its 
	tangent."

	^self asFloat tan! !

!Number methodsFor: 'intervals' stamp: ''!
to: stop
	"Answer an Interval from the receiver up to the argument, stop, 
	incrementing by 1."

	^Interval from: self to: stop by: 1! !

!Number methodsFor: 'intervals' stamp: ''!
to: stop by: step
	"Answer an Interval from the receiver up to the argument, stop, 
	incrementing by step."

	^Interval from: self to: stop by: step! !

!Number methodsFor: 'intervals' stamp: 'tao 1/30/1999 08:58'!
to: stop by: step do: aBlock 
	"Normally compiled in-line, and therefore not overridable.
	Evaluate aBlock for each element of the interval (self to: stop by: 
step)."
	| nextValue |
	nextValue := self.
	step = 0 ifTrue: [self error: 'step must be non-zero'].
	step < 0
		ifTrue: [[stop <= nextValue]
				whileTrue: 
					[aBlock value: nextValue.
					nextValue := nextValue + step]]
		ifFalse: [[stop >= nextValue]
				whileTrue: 
					[aBlock value: nextValue.
					nextValue := nextValue + step]]! !

!Number methodsFor: 'intervals' stamp: ''!
to: stop do: aBlock 
	"Normally compiled in-line, and therefore not overridable.
	Evaluate aBlock for each element of the interval (self to: stop by: 1)."
	| nextValue |
	nextValue := self.
	[nextValue <= stop]
		whileTrue: 
			[aBlock value: nextValue.
			nextValue := nextValue + 1]! !

!Number methodsFor: 'truncation and round off' stamp: 'StephaneDucasse 5/8/2010 17:14'!
truncateTo: aNumber 
	"Answer the next multiple of aNumber toward zero that is nearest the receiver."

	^(self quo: aNumber) * aNumber! !

!Number methodsFor: 'truncation and round off' stamp: ''!
truncated
	"Answer an integer nearest the receiver toward zero."

	^self quo: 1! !

!Number methodsFor: 'converting' stamp: 'brp 1/9/2004 06:19'!
week
 
 	^ self sign weeks
 ! !

!Number methodsFor: 'converting' stamp: 'brp 5/16/2003 07:57'!
weeks
 
 	^ Duration weeks: self! !

!Number methodsFor: 'converting' stamp: 'nice 4/23/2011 02:25'!
withNegativeSign
	"Answer a number with same magnitude than receiver and negative sign."
	^self abs negated! !

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'EzequielBarrios 5/24/2013 10:34'!
canNotConvertMeasurementException
	
	^  Error! !

!MeasureTest methodsFor: 'temperature units' stamp: 'AlejandraRodriguez 5/25/2013 17:26'!
celsius
	
	^ SimpleUnit celsius! !

!MeasureTest methodsFor: 'distance units' stamp: 'AlejandraRodriguez 5/25/2013 17:26'!
centimeter
	
	^ SimpleUnit centimeter! !

!MeasureTest methodsFor: 'time units' stamp: 'AlejandraRodriguez 5/25/2013 17:27'!
day
	
	 ^SimpleUnit day! !

!MeasureTest methodsFor: 'distance units' stamp: 'AlejandraRodriguez 5/25/2013 17:26'!
decameter
	
	^ SimpleUnit decameter! !

!MeasureTest methodsFor: 'distance units' stamp: 'AlejandraRodriguez 5/25/2013 17:26'!
decimeter
	
	^ SimpleUnit decimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'AlejandraRodriguez 5/25/2013 15:44'!
eightCubicMeters

	^ CompoundMeasure amount: 8 inUnit: (self meter * self meter * self meter)! !

!MeasureTest methodsFor: 'temperature units' stamp: 'AlejandraRodriguez 5/25/2013 17:26'!
fahrenheit
	
	^SimpleUnit fahrenheit ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'AlejandraRodriguez 5/26/2013 16:41'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

	^ initialSpeed + (anAcceleration * aTimePeriod)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'AlejandraRodriguez 5/25/2013 15:44'!
fourSquaredMeters

	^ CompoundMeasure amount: 4 inUnit: (self meter * self meter)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'AlejandraRodriguez 5/25/2013 18:17'!
halfMeterBySecond

	^ CompoundMeasure amount: (1/2) inUnit: (self meter / self second)! !

!MeasureTest methodsFor: 'distance units' stamp: 'AlejandraRodriguez 5/25/2013 17:26'!
hectometer
	
	^ SimpleUnit hectometer! !

!MeasureTest methodsFor: 'time units' stamp: 'AlejandraRodriguez 5/25/2013 17:27'!
hour
	
	^SimpleUnit  hour! !

!MeasureTest methodsFor: 'temperature units' stamp: 'AlejandraRodriguez 5/25/2013 17:26'!
kelvin
	
	^SimpleUnit kelvin! !

!MeasureTest methodsFor: 'distance units' stamp: 'AlejandraRodriguez 5/25/2013 17:26'!
kilometer
	
	^SimpleUnit  kilometer! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'AlejandraRodriguez 5/25/2013 17:26'!
meter

	^ SimpleUnit meter! !

!MeasureTest methodsFor: 'distance units' stamp: 'AlejandraRodriguez 5/25/2013 17:26'!
millimeter
	
	^ SimpleUnit millimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AlejandraRodriguez 5/25/2013 18:04'!
minusOneMeter 
	
	^ SimpleMeasure amount: -1 inUnit: self meter! !

!MeasureTest methodsFor: 'time units' stamp: 'AlejandraRodriguez 5/25/2013 17:27'!
minute
	
	^SimpleUnit  minute! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'AlejandraRodriguez 5/25/2013 18:05'!
oneCelsius
	
	^ SimpleMeasure amount: 1 inUnit: self celsius! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AlejandraRodriguez 5/25/2013 18:04'!
oneCentimeter
	
	^ SimpleMeasure amount: 1 inUnit: self centimeter ! !

!MeasureTest methodsFor: 'time measures' stamp: 'AlejandraRodriguez 5/25/2013 18:05'!
oneDay
	
	^ SimpleMeasure amount: 1 inUnit: self day! !

!MeasureTest methodsFor: 'time measures' stamp: 'AlejandraRodriguez 5/25/2013 18:05'!
oneHour
	
	^ SimpleMeasure amount: 1 inUnit: self hour! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AlejandraRodriguez 5/25/2013 18:04'!
oneHundredCentimeters
	
	^ SimpleMeasure amount: 100 inUnit: self centimeter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'AlejandraRodriguez 5/25/2013 15:45'!
oneHundredTwentyOneMetersPerSecond

	^ CompoundMeasure amount: 121 inUnit: (self meter / self second)! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AlejandraRodriguez 5/25/2013 18:04'!
oneMeter
	
	^ SimpleMeasure amount: 1 inUnit: self meter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'AlejandraRodriguez 5/25/2013 15:45'!
oneMeterPerSecond

	^ CompoundMeasure amount: 1 inUnit: (self meter / self second)! !

!MeasureTest methodsFor: 'time measures' stamp: 'AlejandraRodriguez 5/25/2013 18:06'!
oneMinute
	
	^ SimpleMeasure amount: 1 inUnit: self minute! !

!MeasureTest methodsFor: 'time measures' stamp: 'AlejandraRodriguez 5/25/2013 18:06'!
oneSecond

	^ SimpleMeasure amount: 1 inUnit: self second! !

!MeasureTest methodsFor: 'compound measures' stamp: 'AlejandraRodriguez 5/25/2013 14:49'!
oneSquaredMeter

	^ CompoundMeasure amount: 1 inUnit: (self meter * self meter)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'AlejandraRodriguez 5/25/2013 15:46'!
oneSquaredSecond

	^ CompoundMeasure amount: 1 inUnit: (self second * self second)! !

!MeasureTest methodsFor: 'time units' stamp: 'AlejandraRodriguez 5/25/2013 17:27'!
second
	
	^SimpleUnit  second! !

!MeasureTest methodsFor: 'time measures' stamp: 'AlejandraRodriguez 5/25/2013 18:06'!
sixtyMinutes
	
	^ SimpleMeasure amount: 60 inUnit: self minute! !

!MeasureTest methodsFor: 'time measures' stamp: 'AlejandraRodriguez 5/25/2013 18:06'!
sixtyOneSeconds
	
	^ SimpleMeasure amount: 61 inUnit: self second! !

!MeasureTest methodsFor: 'time measures' stamp: 'AlejandraRodriguez 5/25/2013 18:06'!
sixtySeconds
	
	^ SimpleMeasure amount: 60 inUnit: self second! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'EzequielBarrios 5/20/2013 21:29'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'EzequielBarrios 5/22/2013 20:06'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'EzequielBarrios 5/24/2013 01:39'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'AlejandraRodriguez 5/25/2013 18:16'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self oneMeter / self twoSeconds) = self halfMeterBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'AlejandraRodriguez 5/25/2013 18:05'!
thirtyTwoFahrenheits
	
	^ SimpleMeasure  amount: 32 inUnit: self fahrenheit! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'AlejandraRodriguez 5/25/2013 18:06'!
twentyFourHours
	
	^ SimpleMeasure amount: 24 inUnit: self hour! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'AlejandraRodriguez 5/25/2013 18:05'!
twoCelsius
	
	^ SimpleMeasure amount: 2 inUnit: self celsius ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AlejandraRodriguez 5/25/2013 18:04'!
twoHundredCentimeters
	
	^ SimpleMeasure amount: 200 inUnit: self centimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AlejandraRodriguez 5/25/2013 18:04'!
twoMeters
	
	^ SimpleMeasure amount: 2 inUnit: self meter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'AlejandraRodriguez 5/25/2013 15:47'!
twoMetersBySecond

	^ CompoundMeasure amount: 2 inUnit: (self meter / self second)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'AlejandraRodriguez 5/25/2013 15:47'!
twoMetersPerSquaredSecond

	^ CompoundMeasure amount: 2 inUnit: (self meter / self second / self second)
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'AlejandraRodriguez 5/25/2013 15:48'!
twoMetersTimesSecond

	^ CompoundMeasure amount: 2 inUnit: (self meter * self second)! !

!MeasureTest methodsFor: 'time measures' stamp: 'AlejandraRodriguez 5/25/2013 18:06'!
twoSeconds
	
	^ SimpleMeasure amount: 2 inUnit: self second! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'AlejandraRodriguez 5/25/2013 18:05'!
zeroCelsius
	
	^ SimpleMeasure amount: 0 inUnit: self celsius! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'AlejandraRodriguez 5/25/2013 18:05'!
zeroKelvin
	
	^ SimpleMeasure amount: 0 inUnit: self kelvin ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AlejandraRodriguez 5/25/2013 18:04'!
zeroMeters

	^ SimpleMeasure amount: 0 inUnit: self meter.! !

!MeasureTest methodsFor: 'time measures' stamp: 'AlejandraRodriguez 5/25/2013 18:06'!
zeroSeconds
	
	^ SimpleMeasure amount: 0 inUnit: self second! !

Object subclass: #MeasureInterval
	instanceVariableNames: 'first last increment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureInterval class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 15:08'!
from: aSimpleMeasure to: anotherSimpleMeasure
	
	^self new from: aSimpleMeasure to: anotherSimpleMeasure! !

!MeasureInterval class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 15:09'!
from: aSimpleMeasure to: anotherSimpleMeasure by: aThirdSimpleMeasure
	
	^self new from: aSimpleMeasure to: anotherSimpleMeasure by: aThirdSimpleMeasure! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 16:33'!
do: aBlock
	
	|step|
	step:= first.
	[ step <= last] whileTrue: [ aBlock value: step.
								step:= step + increment ]! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 16:34'!
first
	^ first! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 16:33'!
from: aSimpleMeasure to: anotherSimpleMeasure 
	
	first:= aSimpleMeasure.
	last:= anotherSimpleMeasure.
	increment:=  SimpleMeasure amount:  1 inUnit: (aSimpleMeasure unit min: anotherSimpleMeasure unit)! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 16:33'!
from: aSimpleMeasure to: anotherSimpleMeasure by: aThirdSimpleMeasure
	
	first:= aSimpleMeasure.
	last:= anotherSimpleMeasure.
	increment:=  aThirdSimpleMeasure.! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 16:34'!
increment
	^ increment! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 16:34'!
last
	^ last! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 16:33'!
size 

	|fromInUnitOfBy toInUnitOfBy|
	
	fromInUnitOfBy  := first convertTo: increment unit .
	toInUnitOfBy := last convertTo: increment unit.
	^ ((toInUnitOfBy amount - fromInUnitOfBy amount) / increment amount ) +1! !

Object subclass: #Unit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Unit subclass: #CompoundUnit
	instanceVariableNames: 'numeratorUnit denominatorUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!CompoundUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:14'!
initializeWithNumeratorUnit: anOrderedCollectionOfSimpleUnits andDenominatorUnit: anotherOrderedCollectionOfSimpleUnits

	^ self new initializeWithNumeratorUnit: anOrderedCollectionOfSimpleUnits andDenominatorUnit: anotherOrderedCollectionOfSimpleUnits! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:40'!
* anUnit

	|unitFactor1 unitFactor2|
	unitFactor1 := anUnit asCompoundUnit.
	unitFactor2 := self asCompoundUnit.

	^ CompoundUnit initializeWithNumeratorUnit: (unitFactor1 numeratorUnit join: unitFactor2 numeratorUnit) andDenominatorUnit:  (unitFactor1 denominatorUnit join: unitFactor2 denominatorUnit)! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:41'!
/ anUnit

	|unitFactor1 unitFactor2|
	unitFactor1 := anUnit asCompoundUnit.
	unitFactor2 := self asCompoundUnit multiplicativeInverse.

	^ CompoundUnit initializeWithNumeratorUnit: (unitFactor1 numeratorUnit join: unitFactor2 numeratorUnit) andDenominatorUnit:  (unitFactor1 denominatorUnit join: unitFactor2 denominatorUnit)! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:06'!
= anObject


	^ (anObject isKindOf: self class) and: [self numeratorUnit = anObject numeratorUnit] and: [self denominatorUnit = anObject denominatorUnit]! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 18:22'!
adaptToNumber: aNumber andSend: aByteSymbol 

	^ (aByteSymbol = #*) ifFalse: [  ^self error: 'no se interpretar ', aByteSymbol ] ifTrue: [ CompoundMeasure amount: aNumber inUnit: self ]! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:50'!
asCompoundUnit 
	^self! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:04'!
denominatorUnit


	^ denominatorUnit! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:14'!
initializeWithNumeratorUnit: anOrderedCollectionOfSimpleUnits andDenominatorUnit: anotherOrderedCollectionOfSimpleUnits

	numeratorUnit := anOrderedCollectionOfSimpleUnits.
	denominatorUnit := anotherOrderedCollectionOfSimpleUnits.! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:59'!
multiplicativeInverse

	^ CompoundUnit initializeWithNumeratorUnit: self denominatorUnit andDenominatorUnit: self numeratorUnit! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:04'!
numeratorUnit


	^ numeratorUnit! !

Unit subclass: #NullUnit
	instanceVariableNames: 'unitName fromBaseUnitMethod toBaseUnitMethod baseUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!NullUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 17:12'!
initialize
	^ self new initializeUnit: 'nullUnit' withConvertFromBase: [ :a | a ] andConvertToBase: [ :a | a ] andBase: 'nullUnit'! !

!NullUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 17:12'!
initializeUnit: aUnitName withConvertFromBase: aBlockMethod andConvertToBase: anotherBlockMethod andBase: anotherUnitName

	unitName:= aUnitName .
	fromBaseUnitMethod := aBlockMethod.
	toBaseUnitMethod := anotherBlockMethod.
	baseUnit := anotherUnitName.! !

!NullUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 17:14'!
toBaseUnitMethod 

	^toBaseUnitMethod ! !

Unit subclass: #SimpleUnit
	instanceVariableNames: 'unitName toBaseUnitMethod fromBaseUnitMethod baseUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!SimpleUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:34'!
celsius
	
	 ^ (self new) initializeUnit: 'celsius' withConvertFromBase: [ :asKelvinAmount |  asKelvinAmount - 273 ] andConvertToBase: [ :asCelsiusAmount | asCelsiusAmount + 273] andBase: 'kelvin'! !

!SimpleUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:34'!
centimeter


	
	^self new initializeUnit: 'centimeter' withConvertFromBase: [ :a | a*100  ] andConvertToBase: [ :a | a*1/100 ] andBase: 'meter'
	
	! !

!SimpleUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:34'!
day

	^self new initializeUnit: 'day' withConvertFromBase: [ :a | a*1/86400  ] andConvertToBase: [ :a | a*86400 ] andBase: 'second'
! !

!SimpleUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:34'!
decameter

	^self new initializeUnit: 'decameter' withConvertFromBase: [ :a | a*1/10  ] andConvertToBase: [ :a | a*10 ] andBase: 'meter'! !

!SimpleUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:35'!
decimeter

		^self new initializeUnit: 'decimeter' withConvertFromBase: [ :a | a*10  ] andConvertToBase: [ :a | a*1/10 ] andBase: 'meter'! !

!SimpleUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:35'!
fahrenheit
	
	^ (self new) initializeUnit: 'fahrenheit' withConvertFromBase:[ :asKelvinAmount |  32+((9/5)*(asKelvinAmount -  273)) ]  andConvertToBase: [ :asFahrenheitAmount | 273 + (((5*(asFahrenheitAmount - 32))/9)) ] andBase: 'kelvin'
	! !

!SimpleUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:35'!
hectometer

		^self new initializeUnit: 'hectometer' withConvertFromBase: [ :a | a*1/100  ] andConvertToBase: [ :a | a*100 ] andBase: 'meter'! !

!SimpleUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:35'!
hour

	^self new initializeUnit: 'hour' withConvertFromBase: [ :a | a*1/3600] andConvertToBase: [ :a | a*3600] andBase: 'second'
! !

!SimpleUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:35'!
kelvin
	
	^ self new initializeUnit: 'kelvin' withConvertFromBase: [ :a | a ] andConvertToBase: [ :a | a ] andBase: 'kelvin'! !

!SimpleUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:35'!
kilometer

	^self new initializeUnit: 'kilometer' withConvertFromBase: [ :a | a*1/1000  ] andConvertToBase: [ :a | a*1000 ] andBase: 'meter'! !

!SimpleUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:35'!
meter 

		^self new initializeUnit: 'meter' withConvertFromBase: [ :a | a*1 ] andConvertToBase: [ :a | a*1 ] andBase: 'meter'! !

!SimpleUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:35'!
millimeter 

		^self new initializeUnit: 'millimeter' withConvertFromBase: [ :a | a*1000  ] andConvertToBase: [ :a | a*1/1000 ] andBase: 'meter'! !

!SimpleUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:36'!
minute
	
	^self new initializeUnit: 'minute' withConvertFromBase: [ :a | a*1/60  ] andConvertToBase: [ :a | a*60 ] andBase: 'second'! !

!SimpleUnit class methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:36'!
second

	^self new initializeUnit: 'second' withConvertFromBase: [ :a | a*1  ] andConvertToBase: [ :a | a*1 ] andBase: 'second'! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 17:10'!
/ aSimpleUnit

	^ (self isConvertibleTo: aSimpleUnit) ifTrue: [ NullUnit initialize] ifFalse: [ self asCompoundUnit / aSimpleUnit asCompoundUnit ]! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 15:46'!
= anObject 

	^ (anObject isKindOf: self class) and: [ ((self fromBaseUnitMethod value: 1) = (anObject fromBaseUnitMethod value: 1)) and: [ (self unitName = anObject unitName) and: [ self baseUnit = anObject baseUnit]]]! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 18:22'!
adaptToNumber: aNumber andSend: aByteSymbol 

	^ (aByteSymbol = #*) ifFalse: [  ^self error: 'no se interpretar ', aByteSymbol ] ifTrue: [ SimpleMeasure amount: aNumber inUnit: self ]! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:49'!
asCompoundUnit

	| newNumeratorUnit |
	newNumeratorUnit := OrderedCollection new.
	newNumeratorUnit add: self.

	^ CompoundUnit initializeWithNumeratorUnit: newNumeratorUnit andDenominatorUnit: OrderedCollection new! !

!SimpleUnit methodsFor: 'accessing' stamp: 'AlejandraRodriguez 5/25/2013 17:43'!
baseUnit 
	^ baseUnit! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:05'!
fromBaseUnitMethod 

	^fromBaseUnitMethod ! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:42'!
initializeUnit: aUnitName withConvertFromBase: aBlockMethod andConvertToBase: anotherBlockMethod andBase: anotherUnitName

	unitName:= aUnitName .
	fromBaseUnitMethod := aBlockMethod.
	toBaseUnitMethod := anotherBlockMethod.
	baseUnit := anotherUnitName.! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 17:41'!
isConvertibleTo: anUnit

	^ (anUnit isKindOf: self class) and: [self baseUnit = anUnit baseUnit]! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 16:31'!
min: aDistanceUnit
	
	^ { self . aDistanceUnit } detectMin: [ :a | a toBaseUnitMethod value: 1 ]! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:42'!
multiplicativeInverse


	^ self asCompoundUnit multiplicativeInverse.! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:05'!
printString

	^ unitName! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:05'!
toBaseUnitMethod 

	^toBaseUnitMethod ! !

!SimpleUnit methodsFor: 'accessing' stamp: 'AlejandraRodriguez 5/25/2013 17:23'!
unitName
	^ unitName! !

!Unit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/26/2013 17:03'!
* aUnit 

	^ self asCompoundUnit * aUnit asCompoundUnit ! !

!Unit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 16:00'!
/ aUnit 

	^ self asCompoundUnit / self asCompoundUnit ! !

!Unit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:05'!
= aUnit 

	^ self subclassResponsibility ! !

!Unit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 18:22'!
adaptToNumber: aNumber andSend: aByteSymbol 

	^ self subclassResponsibility ! !

!Unit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:36'!
asCompoundUnit

	^ self subclassResponsibility ! !

!Unit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:01'!
multiplicativeInverse

	^ self subclassResponsibility ! !

!Unit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:19'!
multiplyACompoundUnit: aUnit 

	^ self subclassResponsibility ! !

!Unit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/25/2013 15:19'!
multiplyASimpleUnit: aUnit 

	^ self subclassResponsibility ! !
NullUnit initialize!
